// A sample code to FastCodingLibrary
// Database Research Group (c) 2012
// http://db.cs.vsb.cz/

#include "stdafx.h"
#include "FastCodingLibrary.h"

using namespace FastCodingLibrary;

int _tmain(int argc, _TCHAR* argv[])
{
	int encodedBits;
	int numberCount = 10;
	unsigned int mask=0xFFFFFFFF>>(32-sizeof(int)*8);

	// iterates through all coding methods
	for(int methodNumber = ELIAS_DELTA; methodNumber <= ELIAS_FIBONACCI_FAST; methodNumber++)
	{
		// prepare buffers
		// reserve for fill smaller numbers(1 Byte) by integers(4 bytes)
		char * sourceBuffer = new char[4*numberCount+sizeof(int)-1];
		// twice greater is ok for large numbers.
		char * encodedBuffer = new char[4*numberCount*3];
		// twice greater is ok for large numbers.
		char * decodedBuffer = new char[4*numberCount+sizeof(int)-1];

		for (unsigned int i = 0; i < numberCount; i++)
		{
			*((unsigned int *)(sourceBuffer+i*sizeof(int)))=i + 1;
		}

		printf(Coder::methodName(methodNumber));
		printf("\n");

		// method for encoding
		encodedBits = Coder::encode(methodNumber,sizeof(int),sourceBuffer,encodedBuffer,numberCount);
		
		// prints first 4 bytes of encoded buffer
		Coder::print(methodNumber,encodedBuffer,4);
		printf("\n\n");

		// method for decoding
		Coder::decode(methodNumber,sizeof(int),encodedBuffer,decodedBuffer,numberCount);

		//check encode/decode
		for (unsigned int i=0; i < numberCount; i++) 
		{
			unsigned int n1=(*((unsigned int *)(sourceBuffer+i*sizeof(int))))&mask;
			unsigned int n2=(*((unsigned int *)(decodedBuffer+i*sizeof(int))))&mask;
			if (n1!=n2) 
			{
				printf("Error number %d: %d != %d\n",i,n1,n2);
			}
		}
				
		delete sourceBuffer;
		delete encodedBuffer;
		delete decodedBuffer;

		printf("\n\n");
	}

	return 0;
}

